<?php

/**
 * General purpose redirection script
 */

/**
 * Simple redirect script used for redirection based on configuration settings
 */
function redirect($url)
{
    if (!headers_sent()) {
        header('Location: http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).'/'.$url);
    } else {
        die('Could not redirect; Headers already sent (output).');
    }
}

/**
 * Function to parse the url and get its contents
 */
function getURLContents($pagesource)
{
     //$conn = curl_init();

     //curl_setopt($conn, CURLOPT_URL, $pagesource);
     //curl_setopt($conn, CURL_RETURNTRANSFER, TRUE);

     //$htmlsource = curl_exec($conn);

     //curl_close($conn);
     
     $htmlsource = file_get_contents($pagesource);

     return $htmlsource;
}

/**
 * Function to return an array of all the links that have been found in the source
 *
 * @param $html_src string Web-page source code
 * @param $page_url string Web-page URL string
 
function getLinkArray($html_src, $page_url = null, $inksArray = null)
{
    if ($html_src === false) {
        return false;
    }
    $page_url = substr($page_url, -1) == '/' ? substr($page_url, 0, -1) : $page_url;
    $parsed_url = is_null($page_url) ? null : parse_url($page_url);
    preg_match_all("~\s+href\s*=\s*([\"\'])? (?(1) (.*?)\\1 | ([^\s\>]+))~isx", $html_src, $hrefs);
    preg_match_all("~\s+src\s*=\s*([\"\'])? (?(1) (.*?)\\1 | ([^\s\>]+))~isx", $html_src, $srcs);
    $url_array = array ();
    if (preg_match_all('/<a\s+.*?href=[\"\']?([^\"\' >]*)[\"\']?[^>]*>(.*?)<\/a>/i', $html_src, $matches, PREG_SET_ORDER)) {
        foreach($matches as $match) {
            array_push($url_array, $match[1]);
        }
    }
    $src_array = array ();
    if (preg_match_all('/<\s+.*?src=[\"\']?([^\"\' >]*)[\"\']?[^>]*>(.*?)<\/.*>/i', $html_src, $sources, PREG_SET_ORDER)) {
        foreach($sources as $src) {
            array_push($src_array, $src[1]);
        }
    }
    $urlarray = array_merge($hrefs[2], $srcs[2], $url_array, $src_array); //, $href[0], $src[0]);
    $url_list = array_unique($urlarray);
    foreach ($url_list as $url) {
        if ((strlen($url) > 0) and (!preg_match('~^mailto~', $url))) {
            if (!is_null($parsed_url)) {
                $parsed_link = parse_url($url);
                if (!isset($parsed_link['host'])) break;
                $parsed_link['host'] = substr($parsed_link['host'], 0, 4) == 'www.' ? substr($parsed_link['host'], 4) : $parsed_link['host'];
                $parsed_url['host'] = substr($parsed_url['host'], 0, 4) == 'www.' ? substr($parsed_url['host'], 4) : $parsed_url['host'];
                if (substr($url, 0, 7) == 'http://' && $parsed_link['host'] == $parsed_url['host']) {
                    if (validateLink($url) && $url !=  $page_url) {
                        $urls[] = $url;
                    }
                } elseif (substr($url, 0, 7) != 'http://') {
                    $prefix = substr($page_url, -1) == '/' ? substr($page_url, 0, -1) : dirname($page_url);
                    $url = $prefix . ($url[0] == '/' ? '' : '/') . $url;
                    $url = ereg_replace('\/([^\/]*)\/\.\.\/' , '/', $url);
                    if (validateLink($url) && $url !=  $page_url) {
                        $urls[] = $url;
                    }
                }
            } else {
                $urls[] = $url;
            }
        }
    }
    echo "<p>Returning ".count($urls)." urls for <b>$page_url</b><p>\n";
    return $urls;
} 
*/
function getLinkArray($html_src, $page_url = null)
{
    if ($html_src === false) {
        return false;
    }
    $page_url = substr($page_url, -1) == '/' ? substr($page_url, 0, -1) : $page_url;
    $parsed_url = is_null($page_url) ? null : parse_url($page_url);
    preg_match_all("~\s+href\s*=\s*([\"\'])? (?(1) (.*?)\\1 | ([^\s\>]+))~isx", $html_src, $hrefs);
    preg_match_all("~\s+src\s*=\s*([\"\'])? (?(1) (.*?)\\1 | ([^\s\>]+))~isx", $html_src, $srcs);
    $url_array = array ();
    if (preg_match_all('/<a\s+.*?href=[\"\']?([^\"\' >]*)[\"\']?[^>]*>(.*?)<\/a>/i', $html_src, $matches, PREG_SET_ORDER)) {
        foreach($matches as $match) {
            array_push($url_array, $match[1]);
        }
    }
    $src_array = array ();
    if (preg_match_all('/<\s+.*?src=[\"\']?([^\"\' >]*)[\"\']?[^>]*>(.*?)<\/.*>/i', $html_src, $sources, PREG_SET_ORDER)) {
        foreach($sources as $src) {
            array_push($src_array, $src[1]);
        }
    }
    $urlarray = array_merge($hrefs[2], $srcs[2], $url_array, $src_array); //, $href[0], $src[0]);
    $url_list = array_unique($urlarray);
    foreach ($url_list as $url) {
        if ((strlen($url) > 0) and (!preg_match('~^mailto~', $url))) {
            if (!is_null($parsed_url)) {
                $parsed_link = parse_url($url);
                if (isset($parsed_link['host'])) {
                    $parsed_link['host'] = substr($parsed_link['host'], 0, 4) == 'www.' ? substr($parsed_link['host'], 4) : $parsed_link['host'];
                } else {
                    $parsed_link['host'] = '';
                }
                $parsed_url['host'] = substr($parsed_url['host'], 0, 4) == 'www.' ? substr($parsed_url['host'], 4) : $parsed_url['host'];
                if (substr($url, 0, 7) == 'http://' && $parsed_link['host'] == $parsed_url['host']) {
                    if (validateLink($url) && $url !=  $page_url) {
                        $urls[] = $url;
                    }
                } elseif (substr($url, 0, 7) != 'http://') {
                    $prefix = $parsed_url['scheme'] . '://' . $parsed_url['host'];
                    $url = $prefix . ($url[0] == '/' ? '' : '/') . $url;
                    $url = ereg_replace('\/([^\/]*)\/\.\.\/' , '/', $url);
                    if (validateLink($url) && $url !=  $page_url) {
                        $urls[] = $url;
                    }
                }
            } else {
                $urls[] = $url;
            }
        }
    }
    return $urls;
} 

function validateLink($url) {
    if (preg_match('/(\.php|\.phtml|\.html|\.htm|\.xml|\.asp|\.aspx)$/i', $url)) {
        return true;
    } elseif (preg_match('/\/.([^\.]*)(\/|)$/i', $url)) {
        return true;
    } else {

        return false;
    }
}



/**
* Get 100 Words from the first <p>...</p> block *
* @param $html_src string Web-page source code */
function getWords($html_src)
{
	$i = 0;
	$topWords = array();
	preg_match_all('/<p>(.*?)<\/p>/isx', $html_src, $srcs);
	
	foreach ($srcs[1] as $block)
	{
		$block = strip_tags($block, '<b><i><u><strong>');
		preg_match_all('/[a-zA-Z<>\/]*/i', $block, $words);
	
		foreach ($words[0] as $word)
		{
			$word = trim($word);
			if (!in_array($word, $topWords))
			{
				$topWords[] = $word;
				$i++;
				if ($i == 100) return count($topWords) > 0 ? implode(' ', $topWords) : '';            
			}        
		}    
	}    
	return count($topWords) > 0 ? implode(' ', $topWords) : '';
}

/**
 * Function to convert all the links into absolute ones
 */
function conToAbsoluteLinks($url, $domain_path)
{
    if (!preg_match('~^http\:\/\/~', $url))
    {
        if (!preg_match('~^\/~', $url))
        {
            $url = '/'.$url;
        }
        $url = $domain_path.$url;
    }

    return $url;
}


/**
 * Function to split all the urls to their respective categories
 */
function divideURLCategories($urls, $domainpath)
{
    global $result;
    $imgext_array = array ('jpeg', 'jpg', 'gif', 'bmp', 'xbm', 'psd', 'ico', 'png');
    $index_count = array ();

    foreach ($urls as $index=>$url)
    {
        foreach ($imgext_array as $imgext)
        {
            $pattern = "~\.".$imgext."~";
            if (preg_match($pattern, $url))
            {
                array_push($index_count, $index);
                $img_links[] = $url;
            }
        }
        if (preg_match('~\.css$~', $url))
        {
            array_push($index_count, $index);
            $css_links[] = $url;
        }
        if ((preg_match('~\.js$~', $url)) or (preg_match('~^javascript\:.*\(\)$~', $url)))
        {
            array_push($index_count, $index);
            $js_links[] = $url;
        }
        else
        {
            if (!in_array($index, $index_count))
            {
                $links[] = $url;
            }
        }
    }

    if (count($links) > 0)
    {
        $result .= "<b>Links: </b><br><br>";

        foreach ($links as $index=>$link)
        {
                        if (!preg_match('~^javascript~Ui', $link))
                        {
                           $links[$index] = conToAbsoluteLinks($link, $domainpath);
                        }
        }
    }

    return $links;
}


/**
 * Function which replaces all comments, scripts etc to a space so that they do not
 * disrupt the textual content analysis
 */
function returnOnlyContent($text)
{
    preg_match('~<body[^>]*>.*<\/body>~Uis', $text, $matches);
    
    $content = $matches[0];

    $content = preg_replace("~<script[^>]*>.*<\/script>~Uis", " ", $content);

    $content = preg_replace("~<style[^>]*>.*<\/style>~Uis", " ", $content);

    $content = preg_replace("~<a [^>]*>.*<\/a>~Uis", " ", $content);

    $content = preg_replace("~<!--.*-->~Uis", " ", $content);

    //$content = html_entity_decode($content);

    $content = strip_tags($content, "<b><i><br>");

    return $content;
}


/**
 * function to return an array from the content containing of either single words
 * or phrases with two or three words
 */
function getWordList($content, $phrase_len)
{
    if ($phrase_len == 1) {
        //preg_match_all('~\s\w|\W[^\s]*\s~', $content, $matches);
        $matches = preg_split("~\s~Us", $content);
        foreach ($matches as $phrase) {
            $phrase = trim($phrase);
            $word_array[] = $phrase;
        }
    }
    return $word_array;
}

/**
 * Function to weed out known words, articles etc from the word list
 */
function returnFinalContent($words, $stopws, $len)
{
    $cur_len = 0;
    foreach ($words as $word) {
        if (!in_array($word, $stopws)) {
            $wordarray[] = $word;
            $cur_len = $cur_len + 1;
        } elseif (in_array($word, $stopws)) {
            $wordarray[] = $word;
        }
        if ($cur_len >= $len) {
            break;
        }
    }
    $ret_content = implode(" ", $wordarray);
    return $ret_content;
}


/**
 * Main function which makes the individual posts to blogger Atom API
 */
function postToBlogger($author_blogid, $author_username, $author_password, $author_url, $entry_title, $entry_datetime, $entry_content)
{
  
		
	     $entry_datetime=gmdate("Y-m-d\TH:i:s\Z");
		 $author_password	=trim($author_password);
         $xml_schema 		= '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n\r";
         $entry_schema 		= '<entry xmlns="http://purl.org/atom/ns#">'."\n\r";
         $title_line 		= '<title mode="escaped" type="text/plain">'.$entry_title.'</title>'."\n\r";
         $datetime_line 	='<issued>'.$entry_datetime.'</issued>';
         $authormeta_line 	='<generator url="'.trim($author_url).'">'.trim($author_username).'</generator>'."\n\r";
         $content_schema 	= '<content type="application/xhtml+xml">'."\n\r";
         $content_line 		= '<div xmlns="http://www.w3.org/1999/xhtml">'.$entry_content.'</div>'."\n\r";
         $content_end 		= '</content>'."\n\r";
         $entry_end 		= '</entry>'."\n\r";

         $atom_url = "https://www.blogger.com/atom/".trim($author_blogid);

         $atom_post_content = $xml_schema.$entry_schema.$title_line.$datetime_line.$authormeta_line;
         $atom_post_content .= $content_schema.$content_line.$content_end.$entry_end;
         
         $connect = curl_init();

         curl_setopt($connect, CURLOPT_URL, $atom_url);
         curl_setopt($connect, CURLOPT_RETURNTRANSFER, 1);
         curl_setopt($connect, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
         curl_setopt($connect, CURLOPT_HTTPHEADER, array('Content-type: application/xml'));
         curl_setopt($connect, CURLOPT_HEADER, 1);
         curl_setopt($connect, CURLOPT_POST, 1);
         curl_setopt($connect, CURLOPT_VERBOSE, 1);
         curl_setopt($connect, CURLOPT_POSTFIELDS, $atom_post_content);
         curl_setopt($connect, CURLOPT_USERPWD, "$author_username:$author_password");

         $response_content =  curl_exec($connect);
         

         $response = curl_getinfo($connect);

         curl_close($connect);
		
         return $response["http_code"]; 
}

/**
 * Function which handles the ping to pingomatic.com
 */
function doPingOMatic($blog_name, $blog_link)
{
	$xml_schema = '<?xml version="1.0"?>'."\n";
	$methodcall_schema = '<methodCall>'."\n";
	$methodname_line = '<methodName>weblogUpdates.ping</methodName>'."\n";
	$params_schema ='<params>'."\n";
	$blogname_line ='<param><value>'.$blog_name.'</value></param>'."\n";
	$bloglink_line = '<param><value>'.$blog_link.'</value></param>'."\n";

	$params_end = '</params>'."\n";
	$methodcall_end = '</methodCall>'."\n";
	$ping_url = 'http://rpc.pingomatic.com';
	$ping_post_content = $xml_schema.$methodcall_schema.$methodname_line;
	$ping_post_content .= $params_schema.$blogname_line.$bloglink_line;
	$ping_post_content .= $params_end.$methodcall_end;
	$connect = curl_init();
	curl_setopt($connect, CURLOPT_URL, $ping_url);
	curl_setopt($connect, CURLOPT_RETURNTRANSFER, TRUE);
	curl_setopt($connect, CURLOPT_HTTPHEADER, array('Content-Type: text/xml'));
	curl_setopt($connect, CURLOPT_POST, TRUE);
	curl_setopt($connect, CURLOPT_POSTFIELDS, $ping_post_content);
	$response_content =  curl_exec($connect);
	$response = curl_getinfo($connect);
	curl_close($connect);
	return $response["http_code"];
}
?>
